SeedRnd MilliSecs()

Graphics3D 640,480,16
SetBuffer BackBuffer()

Global camera=CreateCamera()
CameraRange camera,0.1,2
CameraClsMode camera,0,1


Global pivot=CreatePivot()
PositionEntity pivot,0,-1.8,0

Global pivot2=CreatePivot()
PositionEntity pivot2,0,-1.8,0

Global lbox=CreateImage(120,120)

Global light=CreateLight()


Global width=320,height=240,started=0,close#,screenpic,debug=0

Global laser=LoadSound("invasion/laser.wav")
Global blown=LoadSound("invasion/explode.wav")
Global didhit=LoadSound("invasion/didhit.wav")
Global cancel=LoadSound("invasion/cancel.wav")
Global ufo=LoadSound("invasion/ufo.wav")
Global collect=LoadSound("invasion/collect.wav")
Global newcrate=LoadSound("invasion/newcrate.wav")
Global runout=LoadSound("invasion/runout.wav")

Global font=LoadFont("arial narrow",22,False)
Global font2=LoadFont("courier",40,False)

SetFont font2

SoundVolume laser,0.3
SoundVolume blown,0.3
SoundVolume ufo,0.3

Type bullet
Field x#,y#,ang#,ally,va,vx#,vy#,out#,split,bull3D
End Type


Type foe
Field out#,fang#,alien,centro,inwave,ensort
Field direc,shield#,weapons,speed,firate,smax#
Field foe3D1,foe3D2,foe3D3,shield3D,current
End Type

Type explo
Field xp#,yp#,frame,count,etype,explo3D
End Type

Type fortress
Field ang#,num,pieces,fort3D
End Type

Type crate
Field out#,ang#,speed#,crate3D
End Type

Type fortchip
Field name,pfort
Field xpos,ypos,width,height
End Type

Type smessage
Field name
End Type


;vars for validation code
Dim e(20),ee(20),d(20)
Dim inscene(10)
Dim xx$(4)
Global code$,rancode=0

Global tpowers=14

Dim powers(tpowers),powtime(tpowers)

Dim pup$(tpowers)
pup$(0)="SUPER SHIELD"
pup$(1)="TRIPLE FIRE"
pup$(2)="SPREAD SHOT"
pup$(3)="RAPID FIRE"
pup$(4)="CRATE SHOWER"
pup$(5)="HYPER SNIPER"
pup$(6)="SPLIT SHOT"
pup$(7)="SLICE BULLETS"
pup$(8)="EARTH DEFENCES"
pup$(9)="SIGNAL BEACON"
pup$(10)="FORTRESS GUNS"
pup$(11)="SHIELD CHARGE"
pup$(12)="DEEP FREEZE"
pup$(13)="TRIPLE SCORE"

Global totwaves,altypes=9
Global wavetime,waverem

Dim alvalue(altypes)
Data 15,30,50,70,70,70,100,100,50

For na=1 To altypes
Read alvalue(na)
Next

Dim alcol(altypes,3)
Data 255,0,0,0,255,0,0,0,255
Data 255,255,0,255,128,0,192,192,192
Data 255,128,192,64,0,128,128,255,128

For mb=1 To altypes
For mc=1 To 3
Read alcol(mb,mc)
Next
Next

Dim asuper(altypes,3)
Data 1,1,1
Data 1,1,1
Data 1,1,1
Data 3,1,1
Data 1,5,1
Data 2,1,1
Data 1,20,1
Data 4,5,1
Data 1,3,3

For mb=1 To altypes
For mc=1 To 3
Read asuper(mb,mc)
Next
Next

Dim wavedata(50,28)

Restore invaderdata

endofdata=0:totwaves=0

Repeat
For md=1 To 28
Read wavedata(totwaves+1,29-md)
If wavedata(totwaves+1,29-md)=-1 Then endofdata=1:md=28
If md=28 And endofdata=0 Then totwaves=totwaves+1
Next
Until endofdata=1

Restore continuedata

;defines the digital layout
;used in the digital() function
;to print the score

.continuedata

Dim section(9,7)

Data 1,0,1,1,1,1,1
Data 0,0,0,0,0,1,1
Data 1,1,1,0,1,1,0
Data 1,1,1,0,0,1,1
Data 0,1,0,1,0,1,1
Data 1,1,1,1,0,0,1
Data 1,1,1,1,1,0,1
Data 1,0,0,0,0,1,1
Data 1,1,1,1,1,1,1
Data 1,1,1,1,0,1,1

For k=0 To 9
For l=1 To 7
Read section(k,l)
Next
Next


Dim centre(7,2)
Data 1,0,1,2,1,4,0,1,0,3,2,1,2,3

For m=1 To 7
For n=1 To 2
Read centre(m,n)
Next
Next

Dim titlestars#(1000,2)
For bs=1 To 1000
titlestars#(bs,1)=Rnd#(800)
titlestars#(bs,2)=Rnd#(600)
Next


Global score=0,mscore=0

Dim val(6)


Dim board$(8)
board$(1)="ZHODANI"
board$(2)="GYANENDRA"
board$(3)="AEL YAEL"
board$(4)="MUSEVENI"
board$(5)="SHEOL"
board$(6)="PASTRANA"
board$(7)="VIRUSHI"
board$(8)="KARIMOV"

Dim vcode$(8)
;vcode$(1)="ABCD-EFGH-IJKL-MNOP-QRST-UVWX"

Dim bosco(8)
Data 30000,25000,20000,15000,10000,6000,4000,2000

For ka=1 To 8
Read bosco(ka)
Next

Global tscreen=LoadImage("invasion/tscreen.jpg")
ScaleImage tscreen,1.5,1.5

earth=LoadImage("invasion/earthpic.bmp")

Dim chipin(10,18,13)


Dim tpix(320,240),pixat(320,240),tspix(320,240),ttpix(320,240),pixcho(320,240)

title=CreateImage(320,240)

SetBuffer ImageBuffer(title)

Color 255,255,255
For ii=1 To 1000
Plot Rnd#(320),Rnd#(240)
Next


;read pixels from imagebuffers

;readbuffer(1,320,240,title)

;readbuffer(2,320,240,tscreen)

;readbuffer(3,160,160,earth)

Global my_timer=CreateTimer(75)

Global newx#,newy#,dist#,ryc#,ox#,oy#,oex#,oey#
Global aliencount,playerdead=0,deadtime=MilliSecs()
Global rshim=0,rcount=0,lives=3,message=1,bullgone=0
Global movein=0,numaliens=0,nplace=0
Global waveref=0,ep=0,ename=0,curson,curstime=MilliSecs()
Global ufohere=0,whizz,foegone=0,bonus,ncomment,comwait
Global comment$,mtoggle=1,ctoggle=0,atoggle=0,ufosound
Global pressed=0,bfired#=0,bhit#=0,menumes,menuwait,help$
Global mprint,dodeath=0,sshim,scount,pulse#=0,fortime=MilliSecs()
Global beatwaves=0,premain=1000,lastscore=0,bodycol=0,trismax,tris
Global casthit=0,eang#=0,messagenum=0,countforts=0
Global nxpos,nypos,nwidth,nheight,oxp,oyp,owi,ohe

Dim many(20),rotate#(20),orbit(20),side(20)
Dim szz(3)

;remember timers on pause
Global burem,forem
Dim powrem(tpowers)

mship=LoadImage("invasion/mship.bmp")
castle=LoadImage("invasion/castle.bmp")

inv1=LoadImage("invasion/alien.bmp")
inv2=LoadImage("invasion/alien2.bmp")
inv3=LoadImage("invasion/alien3.bmp")

Global bugtexture=LoadAnimTexture("invasion/alienmaskframe.bmp",4,23,19,0,27)


Global inv4=LoadImage("invasion/alienmask.bmp")
;Global inv5=

Global shield=LoadImage("invasion/shield.bmp")
HandleImage shield,23,23

Global crat=LoadImage("invasion/crate.bmp")
HandleImage crat,11,11

Global gunner=LoadImage("invasion/littlegun.bmp")
HandleImage gunner,8,8


Dim ali(3,24,24)
Dim cast(53,38)
Dim msh(40,15)
Dim shi(45,45)
Dim indcol(45,45,3)
Dim invcol(3,23,19,3)
Dim cra(30,30)

;readbuffer(7,40,15,mship)

readbuffer(5,53,38,castle)

;readbuffer(4,22,16,inv1)
;readbuffer(8,22,16,inv2)
;readbuffer(9,22,16,inv3)

;readbuffer(10,45,45,shield)
;readbuffer(11,21,21,crat)

;findcols()



Dim inva3D(altypes,3)

Global cnk

;Global bigtexture=LoadTexture("bug

Global ored=128,ogreen=255,oblue=255,tframe=0
Global lredblue#=1,lgreen#=1


For cd=1 To 3

If cd=1 Then image=LoadImage("invasion/alienmask.bmp")
If cd=2 Then image=LoadImage("invasion/alienmask2.bmp")
If cd=3 Then image=LoadImage("invasion/alienmask3.bmp")

olred=128
olgreen=248
olblue=248


SetBuffer ImageBuffer(image)

For cnk=1 To 9


If Not(FileType("invasion/extras/alienbreed_"+cd+"_"+cnk+".bmp"))

For bb=1 To 23
For bc=1 To 19

GetColor(bb-1,bc-1)

aar=ColorRed()
aag=ColorGreen()
aab=ColorBlue()

If Abs(aar-olred)<=8 And Abs(aag-olgreen)<=8 And Abs(aab-olblue)<=8

aar=alcol(cnk,1)
aag=alcol(cnk,2)
aab=alcol(cnk,3)


Color aar,aag,aab
Plot bb-1,bc-1

EndIf


Next
Next

olred=alcol(cnk,1)
olgreen=alcol(cnk,2)
olblue=alcol(cnk,3)


ok=SaveImage(image,"invasion/extras/alienbreed_"+cd+"_"+cnk+".bmp")

EndIf


tframe=cd*8+cnk-9

inva3D(cnk,cd)=loadmaskedsprite("invasion/extras/alienbreed_"+cd+"_"+cnk+".bmp",4,0,128,0)

setupentity(inva3D(cnk,cd),1,0)


Next

Next




Dim fcast(10,53,38)

Global explosion=LoadAnimImage("invasion/explosion.bmp",54,42,0,8)

rocket=LoadImage("invasion/gunbullet.bmp")
HandleImage rocket,4,4

arocket=LoadImage("invasion/alienbullet.bmp")
HandleImage arocket,4,4

Dim rockt(72),arockt(72)

For ja=0 To 72
rockt(ja)=CopyImage(rocket)
RotateImage rockt(ja),ja*5
arockt(ja)=CopyImage(arocket)
RotateImage arockt(ja),ja*5

Next

ScaleImage earth,1.5,1.5

Global swidth#,sheight#


Global earth3D=loadmaskedsprite("invasion/earthpic.bmp",4,255,0,255)

PositionEntity earth3D,0,-1.8,1.6
ScaleSprite earth3D,1.2,1.2
SpriteViewMode earth3D,2

Global filter=loadmaskedsprite("invasion/whiteback.bmp",4,255,0,255)
EntityColor filter,255,190,220
EntityAlpha filter,0.3
SpriteViewMode filter,2
PositionEntity filter,0,0,1
EntityParent filter,pivot
HideEntity filter

Global earthtitle=CopyEntity(earth3D)
PositionEntity earthtitle,0,-0.4,1.6
ScaleSprite earthtitle,0.8,0.8

Global mship3D=loadmaskedsprite("invasion/mship.bmp",4)
setupentity(mship3D,1,0)

Global crate3D=loadmaskedsprite("invasion/cratemask.bmp",4,0,128,0)
setupentity(crate3D,1,0)

Global shil3D=loadmaskedsprite("invasion/shield.bmp",4)
setupentity(shil3D,0.7,0)

Global gunner3D=loadmaskedsprite("invasion/littlegun.bmp",4)
setupentity(gunner3D,1,1)
PositionEntity gunner3D,0,-0.6,1.6,True
ShowEntity gunner3D

Global gunshil3D=CopyEntity(shil3D)
EntityParent gunshil3D,gunner3D
PositionEntity gunshil3D,0,0,0
HideEntity gunshil3D


Global bullet3D=loadmaskedsprite("invasion/gunbullet.bmp",4)
setupentity(bullet3D,1,0)

Global abullet3D=loadmaskedsprite("invasion/alienbullet.bmp",4)
setupentity(abullet3D,1,0)


Global earthshil=CreateSphere()
ScaleEntity earthshil,1.7,1.7,0.1
EntityAlpha earthshil,0.7
EntityColor earthshil,255,255,0
PositionEntity earthshil,0,-1.8,1.6
HideEntity earthshil


Dim expframe(8)

explos=LoadImage("invasion/explosion.bmp")
buf1=ImageBuffer(explos)

For mi=1 To 8

If Not(FileType("invasion/extras/explo_"+mi+".bmp"))


expframe(mi)=CreateImage(54,42)
buf2=ImageBuffer(expframe(mi))

CopyRect(54*(mi-1),0,54,42,0,0,buf1,buf2)

ok=SaveImage(expframe(mi),"invasion/extras/explo_"+mi+".bmp")

EndIf

Next


Dim exp3D(8)

For mi=1 To 8
exp3D(mi)=loadmaskedsprite("invasion/extras/explo_"+mi+".bmp",4)

ScaleSprite exp3D(mi),0.27,0.21
SpriteViewMode exp3D(mi),2

PositionEntity exp3D(mi),0,10,1.6
HideEntity exp3D(mi)

Next

SetFont font

Dim moth$(5)
moth$(1)="OK"
moth$(2)="GOOD"
moth$(3)="GREAT"
moth$(4)="EXCELLENT"
moth$(5)="PERFECT"


Global warning=newsprite("WARNING - SHIELD DESTROYED","warning")
Global incoming=newsprite("WAVE INCOMING","incoming")
Global accuracy=newsprite("ACCURACY BONUS","accuracy")
Global points=newsprite("points","points")


Dim digisp(10)

For gg=1 To 10

gh=gg
If gh=10 Then gh=0
digisp(gh)=newsprite(Str$(gh),Str$(gh))
Next

Dim pupmes(13)
For gg=0 To 13
pupmes(gg)=newsprite(pup$(gg),"power_"+gg)
Next

Dim mothmes(5)
For gg=1 To 5
mothmes(gg)=newsprite(moth$(gg),"mship_"+gg)
Next


SetFont font2


Global fort3D=loadmaskedsprite("invasion/castle.bmp",4)
ScaleSprite fort3D,0.265,0.19

;PositionEntity fort3D,0,-0.3,1.6
SpriteViewMode fort3D,2
EntityOrder fort3D,2
;EntityParent fort3D,pivot
HideEntity fort3D

RotateEntity pivot,0,0,0

Global chip=loadmaskedsprite("invasion/chip.bmp",4,255,255,255)

ScaleSprite chip,0.02,0.022
SpriteViewMode chip,2
PositionEntity chip,0,-0.3,1.6

EntityOrder chip,1
HideEntity chip


block=loadmaskedsprite("invasion/block.bmp",4)

setupentity(block,1,1)

EntityOrder block,1
PositionEntity block,0,-0.7,1.6,True
ShowEntity block
EntityParent block,gunner3D

EntityParent camera,pivot
PositionEntity camera,0,1.8,0




Dim pix(300,300)
Dim star(1000,4)

Dim ango#(400,400)
Dim edis#(400,400)


;precalculation of angles, distances and sines
;to allow fast WritePixel routines

For iu=1 To 400
For iv=1 To 400

rya#=iu-200
ryb#=iv-200
If rya#=0 Then rya#=0.1
If ryb#=0 Then ryb#=0.1
ryc#=ATan#(rya#/ryb#)
If ryb#<0 Then ryc#=180+ryc#
ango#(iu,iv)=ryc#
edis#(iu,iv)=(rya#^2+ryb#^2)^0.5

Next
Next

Dim theang#(3600,2)

For iu=0 To 3600

theang#(iu,1)=Sin(iu/10)
theang#(iu,2)=Cos(iu/10)

Next

Dim realpix(100,100)


starpos()

;readbuffer(6,239,239,earth)

SetBuffer BackBuffer()

Global angle#=0,maxh,speed#=0,butime=MilliSecs()
Global frams=0,tframs=0,frate=MilliSecs()
Global onpage=1,titlerun=1,tchange=MilliSecs(),musc
Global canim=1,cdiff=1,ccount=0

reset()
load()



Repeat

If mtoggle=1 And ChannelPlaying(musc)=False
musc=PlayMusic("invasion/fleet.xm")
ChannelVolume musc,0.7
EndIf

ingame=0
If onpage=2 Then game()
If onpage=1 And ingame=0 Then titlepage()

toggles(1)

frams=frams+1
	
	If MilliSecs()-frate>1000
	frate=frate+1000
	tframs=frams
	frams=0
	EndIf
	
	countchip=0
	For hchip.fortchip = Each fortchip
	countchip=countchip+1
	Next
	
	
;Text 0,240,"Frames/Sec = "+tframs

;Text 0,270,"Fortress Chips = "+countchip

tris=tris+TrisRendered()
;Text 0,150,"Tris Rendered = "+tris
If tris>trismax Then trismax=tris
;Text 0,180,"Tris Max = "+trismax


TurnEntity pivot,0,0,-angle#-EntityRoll(pivot)

If mprint>0 Then statement(mprint)

Flip
Cls


Color 255,255,255

If onpage=1 And ingame=0

For dk=1 To 1000

vx#=320+(titlestars#(dk,1)-400)*(1+Sin(eang#)*0.2)
vy#=240+(titlestars#(dk,2)-300)*(1+Cos(eang#)*0.2)

Rect vx#,vy#,2,2

Next

EndIf


If onpage=2

For kt=1 To 1000

vang#=star(kt,4)-angle#

vx#=320+star(kt,3)*Sin(vang#)
vy#=600-star(kt,3)*Cos(vang#)

If vx#>=0 And vx#<=640 And vy#>=0 And vy#<=480

Plot vx#,vy#

EndIf

Next



For kan.foe = Each foe
If onscreen(kan\current)=False 
HideEntity kan\current
;kan\shown=0
EndIf

Next

For kao.fortress = Each fortress

inscene(kao\num)=1

If onscreen(kao\fort3D)=False
HideEntity kao\fort3D
inscene(kao\num)=0
EndIf

Next

For kap.crate = Each crate
If onscreen(kap\crate3D)=False
HideEntity kap\crate3D
EndIf
Next


For kc.fortchip = Each fortchip

If inscene(kc\pfort)=1

ShowEntity kc\name

EndIf

Next

For kd.bullet = Each bullet
If onscreen(kd\bull3D)=True Then ShowEntity kd\bull3D
Next

EndIf

UpdateWorld
RenderWorld
tris=TrisRendered()

WaitTimer my_timer

Until False

End




Function game()


ingame=1

If powers(12)=0 Then ccount=ccount+1
If ccount=10
ccount=0
;canim=2:cdiff=1
oanim=canim
canim=canim+cdiff
If canim=3 Then cdiff=-1
If canim=1 Then cdiff=1

For kan.foe = Each foe
If kan\ensort=1
HideEntity kan\current
If canim=1 Then kan\current=kan\foe3D1
If canim=2 Then kan\current=kan\foe3D2
If canim=3 Then kan\current=kan\foe3D3
;If onscreen(kan\current)=True Then ShowEntity kan\current
EndIf
Next

EndIf

If KeyHit(1) Then pressed=2
If JoyHit(5) Then pressed=2

If pressed=2
reset()
scoring()

Return(True)
EndIf


If started<5 Then butime=MilliSecs()

If playerdead=1 And dodeath=0 And MilliSecs()-deadtime>500 Then mprint=message:dodeath=1

If playerdead>0 And MilliSecs()-deadtime>1000
playerdead=playerdead+1

If playerdead=2

If lives=0
reset()
scoring()

Return(True)
EndIf

EndIf


If playerdead=3
playerdead=0:rshim=0:rcount=0
ShowEntity gunner3D
EndIf

deadtime=MilliSecs()

EndIf

If playerdead=2
rcount=rcount+1
If rcount=5
rshim=1-rshim
If rshim=0 Then ShowEntity gunner3D
If rshim=1 Then HideEntity gunner3D
rcount=0
EndIf
EndIf

playerstuff()


;drawearth()
;TurnEntity earth3D,0,0,angle#-EntityRoll(earth3D)

;If playerdead<>1 And rshim=0 Then DrawImage gunner,160,180

If sshim=0 And pulse#>0

;LockBuffer()
;drawthing(160,180,0,pulse#,4)
;UnlockBuffer()

EndIf

shieldlim#=1.5:gen#=0
If powers(0)=1 Then shieldlim#=3:gen#=0.001
If powers(11)=1 Then gen#=0.005

If pulse#>0 And pulse#<shieldlim#

pulse#=pulse#+gen#
If Int(pulse#*1000) Mod 10=0 Or powers(11)=1
shieldcolor(gunshil3D,pulse#)

EndIf

EndIf


scount=scount+50
If scount=3600 Then scount=0
sshim=1-sshim

bullcontrol()

drawvaders()



;draw forts

;If debug=0 Then LockBuffer

If movein>200 Then movein=0
movein=movein+1

;For fort.fortress = Each fortress
;xypos(150,fort\ang#)
;drawthing(newx#,newy#,ryc#,fort\num,2)
;Next



For acrate.crate = Each crate

crategone=0

xypos(acrate\out#,acrate\ang#)

pang#=acrate\ang#
pdis#=acrate\out#/100

PositionEntity acrate\crate3D,Sin(pang#)*pdis#,Cos(pang#)*pdis#-1.8,1.6

;drawthing(newx#,newy#,ryc#,0,5)

If ((newx#-160)^2+(newy#-180)^2)^0.5<15 And playerdead<>1

;get a power-up
PlaySound collect

lookon=1:lcount=0

While lookon=1 And lcount<100
lcount=lcount+1
reward=Int(Rnd#(tpowers)-0.5)

If powers(reward)=0 Then lookon=0
Wend


powers(reward)=1
If reward=4 Then powers(9)=0
If reward=9 Then powers(4)=0
powtime(reward)=MilliSecs()
If reward=11 And pulse#=0 Then pulse#=0.001
If reward=0 Then pulse#=3
If reward=8 Then ShowEntity earthshil

If reward=0 Or reward=11
ShowEntity gunshil3D
shieldcolor(gunshil3D,pulse#)
EndIf


If reward=13
ShowEntity filter
EndIf

ncomment=1
comment$=pup$(reward)
comwait=MilliSecs()
bonus=1
crategone=1

newmessage(5,reward)

EndIf

acrate\out#=acrate\out#-acrate\speed#
acrate\speed#=acrate\speed#+0.01

If acrate\out#<110
newexplo(160+120*Sin(acrate\ang#),300-120*Cos(acrate\ang#),0)
crategone=1
EndIf


If crategone=1

FreeEntity acrate\crate3D
Delete acrate

EndIf

Next

;If debug=0 Then UnlockBuffer


;draw explosions

For bang.explo = Each explo

radial(bang\xp#,bang\yp#)

If bang\etype=0 Then nx#=-13:ny#=-8
If bang\etype=1 Then nx#=-20:ny#=-20


nx#=-24:ny#=-19
;DrawImage explosion,newx#+nx#,newy#+ny#,bang\frame

If playerdead=0 And pulse#=0


If ImagesCollide(explosion,newx#+nx#,newy#+ny#,bang\frame,gunner,160,180,0)
message=6
youexplode()
EndIf

EndIf


If pulse#>0

If ImagesCollide(explosion,newx#+nx#,newy#+ny#,bang\frame,shield,160,180,0)
pulse#=pulse#-0.1
If pulse#>0
shieldcolor(gunshil3D,pulse#)
EndIf
If pulse#<=0
pulse#=0
HideEntity gunshil3D
EndIf

EndIf

EndIf


bang\count=bang\count+1
If bang\count=5
bang\count=0:bang\frame=bang\frame+1

If bang\frame<8 And bang\etype=0
FreeEntity bang\explo3D
bang\explo3D=CopyEntity(exp3D(bang\frame))
PositionEntity bang\explo3D,(bang\xp#/100)-1.6,1.2-(bang\yp#/100),1.6
EndIf

If bang\frame=8 Or bang\etype=1
FreeEntity bang\explo3D
Delete bang
EndIf

EndIf

Next


;create enemy bullets

For nfoe.foe = Each foe

If powers(12)=0

chance#=Rnd#(many(nfoe\inwave)*100)

If chance#<nfoe\firate
xypos(nfoe\out#,nfoe\fang#)

atrip=0:asp=0
If nfoe\weapons=2 Then atrip=1
If nfoe\weapons=3 Then asp=1
If nfoe\weapons=4 Then atrip=1:asp=1

newbullets(atrip,asp,ox#,oy#,0,180+nfoe\fang#,2,0)

EndIf

EndIf

Next


;If aliencount<=10+beatwaves And started=5 Then newwave()

If powers(12)=1 Then wavetime=wavetime+75

If started=5
If MilliSecs()-wavetime>15000 Or aliencount<=10 Then newwave()
EndIf

If ufohere=0
uforan#=Rnd#(2000)
If uforan#<=1 Then ufoarrives()
EndIf

If ufohere=1 And MilliSecs()-whizz>=900
ufosound=PlaySound(ufo)
whizz=MilliSecs()
EndIf


foecollides()

;map()

youscore()



If started<5
started=started+1
If started=5 Then mprint=5
EndIf


powran=500
If powers(4)=1 Then powran=powran/10
If powers(9)=1 Then powran=powran/2
cratein#=Rnd#(powran)

If cratein#<=1
acrate = New crate
acrate\out#=350
If powers(9)=0 Then acrate\ang#=Rnd#(360)
If powers(9)=1 Then acrate\ang#=angle#
acrate\speed#=0
acrate\crate3D = CopyEntity(crate3D)
RotateEntity acrate\crate3D,0,0,-acrate\ang#

PlaySound newcrate
EndIf


If powers(10)=1 And MilliSecs()-fortime>500

fortime=MilliSecs()

countforts=0

For fort.fortress = Each fortress

countforts=countforts+1

If fort\pieces>=500
newbullets(0,0,160,300,160,fort\ang#,3,0)
EndIf

Next

If countforts>0 Then PlaySound laser

EndIf


For mb=0 To tpowers
If powers(mb)=1
If MilliSecs()-powtime(mb)>15000
powers(mb)=0
PlaySound runout
If mb=8 Then HideEntity earthshil
If mb=13 Then HideEntity filter
EndIf
EndIf

Next


zmessage#=2

For this.smessage = Each smessage

If zmessage#-EntityZ(this\name,True)>0.1

MoveEntity this\name,0,0.005,0

EndIf

;PointEntity camera,this\name

zmessage#=EntityZ(this\name,True)

If zmessage#>1

FreeEntity this\name
Delete this

EndIf 


Next

mapview()

End Function



Function mapview()

;SetBuffer ImageBuffer(lbox)

Color 0,255,0
Rect 519,0,120,120,False
;Rect 0,0,50,50
PositionEntity camera,0,0,-1.5
CameraViewport camera,520,1,118,118
CameraRange camera,2.8,3.5

For ka.foe = Each foe
ShowEntity ka\current
Next

For kb.fortress = Each fortress
ShowEntity kb\fort3D
Next

For kc.fortchip = Each fortchip
HideEntity kc\name
Next

For kd.bullet = Each bullet
HideEntity kd\bull3D
Next

For ke.crate = Each crate
ShowEntity ke\crate3D
Next


RenderWorld()

PositionEntity camera,0,1.8,0
CameraViewport camera,0,0,640,480 
CameraRange camera,0.1,2
;SetBuffer BackBuffer()

;DrawImage lbox,520,0


End Function



			
Function starpos()

;set up star positions (in game)

For k=1 To 1000

While star(k,3)<100

star(k,1)=Rnd#(1920)-640
star(k,2)=Rnd#(1200)

ssa#=star(k,1)-320:ssb#=star(k,2)-600

star(k,3)=((ssa#)^2+(ssb#)^2)^0.5

Wend

star(k,4)=ATan(ssa#/ssb#)

If ssb#<0 Then star(k,4)=180+star(k,4)

Next

End Function

Function radial(oldx#,oldy#)

;converts actual position into position
;when rotated by the gunner's angle.
;This is used for drawing objects.

rya#=oldx#-160
ryb#=oldy#-300

dist#=(rya#^2+ryb#^2)^0.5
ryc#=ATan#(rya#/ryb#)
If ryb#<0 Then ryc#=180+ryc#

newx#=160+Sin(ryc#+angle#)*dist#
newy#=300+Cos(ryc#+angle#)*dist#

End Function

Function xypos(out#,ang#)

;converts out# (distance from earths centre) and ang# (angle)
;into x,y co-ordinates, both true (ox#,oy#) and based on the
;gunner's angle (newx#,newy#)

ryc#=ang#-angle#
If ryc#<0 Then ryc#=ryc#+360
newx#=160+Sin(ryc#)*out#
newy#=300-Cos(ryc#)*out#

ox#=160+Sin(ang#)*out#
oy#=300-Cos(ang#)*out#

End Function


Function youexplode()

newexplo(160+120*Sin(angle#),300-120*Cos(angle#),0)
playerdead=1
HideEntity gunner3D
dodeath=0
If lives>0 Then lives=lives-1
deadtime=MilliSecs()

pulse#=0
For ll=1 To tpowers
powers(ll)=0
Next

End Function

Function youscore()

;Text 0,200,EntityRoll(camera)
SetFont font2

Color 0,255,0
Text 0,0,"SCORE"
digital(score,6,120,0)

Text 0,50,"LIVES"
digital(lives,2,120,50)

;Text 0,60,"HIGH SCORE"
;digital(bosco(1),6,-60,80)
;Text 0,60,bhit#/bfired#
SetFont font

End Function

Function statement(info)

mprint=0

Color 128,128,128
Rect 0,240,640,40

Color 0,0,0
If info=1 Then mm$="YOU WERE BLASTED TO ATOMS"
If info=2 Then mm$="AN ALIEN HAS INVADED EARTH"
If info=3 Then mm$="YOU COLLIDED WITH AN ALIEN"
If info=4 Then mm$="GAME PAUSED"
If info=5 Then mm$="PREPARE YOURSELF !!!"
If info=6 Then mm$="AN EXPLOSION CAUGHT YOU"
;If lives=0 Then mm$="GAME OVER"

waverem=MilliSecs()-wavetime

If info=4
burem=MilliSecs()-butime
forem=MilliSecs()-fortime

For ka=1 To tpowers
powrem(ka)=MilliSecs()-powtime(ka)
Next

EndIf

SetFont font2

Text 320-StringWidth(mm$)/2,240,mm$

If lives=0
Color 128,128,128
Rect 0,285,640,40

Color 0,0,0
nn$="GAME OVER"
Text 320-StringWidth(nn$)/2,285,nn$
EndIf

;DrawImage gameover,30,100

SetFont font

screenpic=CreateImage(640,480)
GrabImage screenpic,0,0
MaskImage screenpic,255,255,0

Flip

SetBuffer FrontBuffer()

If ctoggle=0 Then FlushKeys()
If ctoggle=1 Then FlushJoy()


endelay=MilliSecs()+2000
pressed=0

While pressed=0
If lives>0 Or endelay<MilliSecs()
If KeyHit(1) Then pressed=2
If ctoggle=0 And KeyHit(57) Then pressed=1
If ctoggle=0 And KeyHit(208) Then pressed=1
If ctoggle=1 And JoyHit(1) Then pressed=1
If ctoggle=1 And JoyHit(2) Then pressed=1
EndIf

toggles(2)

Wend

If ctoggle=0 Then FlushKeys()
If ctoggle=1 Then FlushJoy()

SetBuffer BackBuffer()

butime=MilliSecs()
wavetime=MilliSecs()-waverem

If info=4
butime=MilliSecs()-burem
fortime=MilliSecs()-forem

For ka=1 To tpowers
powtime(ka)=MilliSecs()-powrem(ka)
Next

EndIf

If info<4 Or info=6
deadtime=MilliSecs()-2000
HideEntity filter
HideEntity earthshil
EndIf

End Function

Function castcol(xx#,yy#)


;checks for collision with forts
;also pinpoints the area of the fort
;which has been hit, and deletes some
;pixels accordingly

For fort.fortress = Each fortress

xypos(150,fort\ang#)

kk#=xx#-ox#
ll#=yy#-oy#

dss#=(kk#^2+ll#^2)^0.5

If dss#<30

tyc#=ATan#(kk#/ll#)
If ll#<0 Then tyc#=180+tyc#

nnx=25+Sin(tyc#+fort\ang#)*dss#
nny=19+Cos(tyc#+fort\ang#)*dss#

If nnx Mod 3=1 Then nnx=nnx+1
If nnx Mod 3=0 Then nnx=nnx-1
If nny Mod 3=0 Then nny=nny+1
If nny Mod 3=2 Then nny=nny-1



If nnx>=5 And nnx<=46 And nny>=0 And nny<=33
If fcast(fort\num,nnx,nny)>-16777216



makechip(fort.fortress,nnx-25,nny-19)




For bac=-2 To 2
For bad=-2 To 2 

If nnx+bac>=0 And nnx+bac<=53 And nny+bad>=0 And nny+bad<=38
fcast(fort\num,nnx+bac,nny+bad)=-16777216
EndIf

Next
Next

premain=0

For bae=0 To 53
For baf=0 To 38
If fcast(fort\num,bae,baf)>-16777216 Then premain=premain+1
Next
Next

fort\pieces=premain

If premain<100

newexplo(160+150*Sin(fort\ang#),300-150*Cos(fort\ang#),0)

For ka.fortchip = Each fortchip

If ka\pfort = fort\num

FreeEntity ka\name
Delete ka

EndIf

Next

HideEntity fort\fort3D
Delete fort

comment$="WARNING: SHIELD DESTROYED !"
ncomment=1
comwait=MilliSecs()

newmessage(1,0)

EndIf

;EndIf

Return(True)

EndIf

EndIf

EndIf

Next

Return(False)

End Function

Function makechip(fort.fortress,xdx,ydy)

oox=(xdx+23)/3
ooy=(ydy+18)/3

If chipin(fort\num,oox,ooy)=0


chipin(fort\num,oox,ooy)=1
aaa=1:doneup=0

If aaa=1
doneup=mergechip(fort.fortress,xdx*2,ydy*2,1,1)
EndIf


If doneup=0

fchip.fortchip = New fortchip

fchip\name = CopyEntity(chip)
EntityParent fchip\name,pivot2

fchip\pfort = fort\num
fchip\xpos = xdx*2
fchip\ypos = ydy*2
fchip\width = 1
fchip\height = 1
casthit=fort\num

TurnEntity pivot2,0,0,-(fort\num*36)-18
EntityParent fchip\name,0
nxx#=xdx
nyy#=ydy
MoveEntity fchip\name,nxx#/100,-nyy#/100,0

EndIf

While doneup=1
;If KeyHit(1) Then End

oxp=nxpos:oyp=nypos:ohe=nheight:owi=nwidth

doneup=mergechip(fort.fortress,nxpos,nypos,nheight,nwidth)

If doneup=1

For cd.fortchip = Each fortchip

If cd\xpos=oxp And cd\ypos=oyp And cd\height=ohe And cd\width=owi

FreeEntity cd\name
Delete cd

EndIf

Next

EndIf

Wend

EndIf

End Function



Function mergechip(fort.fortress,xox,yoy,hoh,wow)

For gchip.fortchip = Each fortchip


If gchip\pfort=fort\num

If gchip\ypos=yoy And gchip\xpos<>xox And gchip\height=hoh And gchip\width*3+wow*3=Abs(xox-gchip\xpos)

xold=gchip\xpos

sizedist=gchip\width*3-wow*3
If gchip\xpos<xox Then sizedist=-sizedist

gchip\xpos=(gchip\xpos+xox+sizedist)/2
gchip\width=gchip\width+wow

ScaleEntity gchip\name,gchip\width*0.75+0.25,gchip\height*0.75+0.25,1

eee#=gchip\xpos-xold

MoveEntity gchip\name,eee#/200,0,0

nxpos=gchip\xpos
nypos=gchip\ypos
nwidth=gchip\width
nheight=gchip\height

Return(True)

EndIf

If gchip\xpos=xox And gchip\ypos<>yoy And gchip\width=wow And gchip\height*3+hoh*3=Abs(yoy-gchip\ypos)

yold=gchip\ypos

sizedist=gchip\height*3-hoh*3
If gchip\ypos<yoy Then sizedist=-sizedist

gchip\ypos=(gchip\ypos+yoy+sizedist)/2
gchip\height=gchip\height+hoh

ScaleEntity gchip\name,gchip\width*0.75+0.25,gchip\height*0.75+0.25,1

eee#=gchip\ypos-yold

MoveEntity gchip\name,0,-eee#/200,0

nxpos=gchip\xpos
nypos=gchip\ypos
nwidth=gchip\width
nheight=gchip\height

Return(True)

EndIf

EndIf


Next


Return(False)

End Function


Function hitcheck(ey#,ez#)

;for bullet collision with fort

If dist#>135 And dist#<165

If castcol(ey#,ez#)

bullgone=1
PlaySound didhit
newexplo(ey#,ez#,1)

EndIf

EndIf

End Function

Function digital(number,digits,xdisp,ydisp)

;display score/lives in a digital format

fb=Len(number)

For fa=1 To 6
val(fa)=0
Next
For fa=1 To fb
val(fa+digits-fb)=Mid(number,fa,1)
Next


For s=1 To digits

;For t=1 To 7

;If t<4 Then aa=10:ab=2
;If t>3 Then aa=2:ab=10

;If section(val(s),t)=1
;Rect s*25+centre(t,1)*8-aa/2+xdisp,centre(t,2)*6-ab/2+ydisp+8,aa,ab
;EndIf
;next


Text s*20+xdisp,ydisp,val(s)


Next

End Function

Function newwave()

beatwaves=beatwaves+1
wavetime=MilliSecs()

waveref=1
While many(waveref)>0
waveref=waveref+1
Wend

many(waveref)=0
orbit(waveref)=1
rotate#(waveref)=0.5
side(waveref)=0

wavemem=0

For ah=200 To 260 Step 20

For ag=-30 To 30 Step 10

bb=beatwaves Mod totwaves
If bb=0 Then bb=totwaves
wavemem=wavemem+1
ww=wavedata(bb,wavemem) Mod 10
wx=wavedata(bb,wavemem)/10
If ww=0 And wx>0 Then ww=10:wx=wx-1

If ww>0

many(waveref)=many(waveref)+1

nfoe.foe = New foe
nfoe\out#=ah+150
nfoe\alien=ww
nfoe\centro=nplace
nfoe\fang#=nfoe\centro+ag
nfoe\inwave=waveref
nfoe\ensort=1
nfoe\direc=1
nfoe\weapons=asuper(nfoe\alien,1)
nfoe\firate=asuper(nfoe\alien,2)
nfoe\speed=asuper(nfoe\alien,3)
nfoe\shield#=wx*0.3
nfoe\smax#=wx*0.3
;nfoe\shown=1

;invafind.inva = Object.inva(2)

;nfoe\foe3D1=CopyEntity(inva3D(nfoe\alien,1))

nfoe\foe3D1=CopyEntity(inva3D(nfoe\alien,1))
nfoe\current=nfoe\foe3D1
nfoe\foe3D2=CopyEntity(inva3D(nfoe\alien,2))
nfoe\foe3D3=CopyEntity(inva3D(nfoe\alien,3))


If nfoe\shield#>0
nfoe\shield3D=CopyEntity(shil3D)

shieldcolor(nfoe\shield3D,nfoe\shield#)


EndIf


EndIf

Next

Next


nplace=nplace+90
If nplace=360 Then nplace=0
comment$="WAVE "+beatwaves+" INCOMING"
ncomment=1
comwait=MilliSecs()

newmessage(2,beatwaves)

End Function

Function foedie(nfoe.foe,how)

newexplo(ox#,oy#,0)
many(nfoe\inwave)=many(nfoe\inwave)-1


If nfoe\ensort=1 And many(nfoe\inwave)=0


If how=1

;bonus=((bhit#/bfired#)-0.5)*2000

bonus=((bhit#/bfired#)^2)*bhit#*35
;If powers(13)=1 Then bonus=bonus*2
If bonus<0 Then bonus=0
bhit#=0:bfired#=0

If bonus>0
score=score+bonus
ncomment=1
comment$="ACCURACY BONUS"
comwait=MilliSecs()

newmessage(3,bonus)

EndIf

EndIf

EndIf

If nfoe\ensort=2
StopChannel ufosound
ufohere=0
EndIf

foegone=1

FreeEntity nfoe\foe3D1
If nfoe\ensort=1
FreeEntity nfoe\foe3D2
FreeEntity nfoe\foe3D3
EndIf

If nfoe\shield#>0
FreeEntity nfoe\shield3D
EndIf

Delete nfoe

End Function

Function scoreboard()

zx#=MouseX()
zy#=MouseY()
bx=0
If zx#>50 And zx#<270
bx=Int(((zy#-30)/20))
If bx<0 Then bx=0
If bx>8 Then bx=0
EndIf

If MilliSecs()-curstime>200
curstime=MilliSecs()
curson=1-curson
EndIf

Color 255,255,0
If ename=0 Then Text 100,10,"HALL OF CHAMPIONS"
If ename=1 Then Text 100,10,"ENTER YOUR NAME !"

For ka=1 To 8

If ka=2 Then Color 0,255,0

cursor$=""
If ename=1 And ka=ep And curson=1 Then cursor$="_"

Text 100,40+ka*40,board$(ka)+cursor$
digital(bosco(ka),6,360,40+ka*40)

If ename=1

tchange=MilliSecs()
value=GetKey()
If value=4 Or value=8
value=0
If Len(board$(ep))>0 Then board$(ep)=Left$(board$(ep),Len(board$(ep))-1)
EndIf

If value=13
ename=0:value=0
save()
FlushKeys()
FlushJoy()
EndIf

If value>0 And StringWidth(board$(ep))<220
If value>96 And value<123 Then value=value-32
board$(ep)=board$(ep)+Chr$(value)
EndIf


EndIf

Next


If lastscore>0
Color 255,128,0
Text 200,440,"LAST SCORE"
digital(lastscore,6,450,440)
EndIf

End Function

Function titlepage()

If KeyHit(1) Then End
If JoyHit(5) Then End

If titlerun=1
ShowEntity earthtitle
EndIf

If titlerun=2
HideEntity earthtitle
EndIf

If MilliSecs()-tchange>5000
titlerun=3-titlerun
tchange=MilliSecs()
EndIf

eang#=eang#+5
ScaleSprite earthtitle,0.8*(1+Sin(eang#)*0.2),0.8*(1+Cos(eang#)*0.2)
TurnEntity earthtitle,0,0,2
;drawit(640,480,-10,-10,1,0.8)	;draw stars
;If titlerun=1 Then drawit(320,120,30,0,2,1.2)	;draw title banner
;If titlerun=1 Then drawit(160,160,90,100,3,1.2)	;draw the earth

If titlerun=1 Then DrawImage tscreen,80,0

If titlerun=2 Then scoreboard()


If ename=0
Color 255,255,0
If ctoggle=0 Then Text 0,400,"PRESS SPACE"
If ctoggle=1 Then Text 0,400,"PRESS JOY 1"
Text 0,440,"TO PLAY"

If ctoggle=0 And KeyHit(57) Then onpage=2
If ctoggle=1 And JoyHit(1) Then onpage=2

If onpage=2
SetFont font
ShowEntity gunner3D
ShowEntity earth3D
HideEntity earthtitle
If ctoggle=0 Then FlushKeys()
If ctoggle=1 Then FlushJoy()
EndIf

;If KeyHit(1) Then End
EndIf

End Function


Function reset()

SetFont font2

If ChannelPlaying(ufosound)=True
StopChannel ufosound
EndIf

onpage=1
pressed=0
sshim=1
mscore=score
lastscore=score
started=0:angle#=0
score=0:lives=3
nplace=0:bonus=0
ncomment=0
titlerun=1
tchange=MilliSecs()
ufohere=0
playerdead=0
rshim=0:rcount=0
bhit#=0:bfired#=0
beatwaves=0
pulse#=0
ShowEntity gunner3D

For bb=0 To tpowers
powers(bb)=0
Next
HideEntity earthshil
HideEntity gunshil3D
HideEntity filter

For this.smessage = Each smessage

FreeEntity this\name
Delete this

Next


For au.foe = Each foe
FreeEntity au\foe3D1
FreeEntity au\foe3D2
FreeEntity au\foe3D3

If au\shield#>0
FreeEntity au\shield3D
EndIf

Delete au
Next

For av.bullet = Each bullet
FreeEntity av\bull3D
Delete av
Next

For aw.explo = Each explo
FreeEntity aw\explo3D
Delete aw
Next

For ax.fortress = Each fortress
FreeEntity ax\fort3D
Delete ax
Next

For ay.crate = Each crate
FreeEntity ay\crate3D
Delete ay
Next

For az.fortchip = Each fortchip
FreeEntity az\name
Delete az
Next

For z=1 To 10
fort.fortress = New fortress
fort\ang#=z*36+18
fort\num=z
fort\pieces=1000
many(z)=0

fort\fort3D=CopyEntity(fort3D)
PositionEntity fort\fort3D,0,-0.3,1.6
RotateEntity pivot2,0,0,0

EntityParent fort\fort3D,pivot2
TurnEntity pivot2,0,0,-18-z*36
EntityParent fort\fort3D,0

HideEntity fort\fort3D

Next

For i=1 To 10
For j=0 To 53
For k=0 To 38
	fcast(i,j,k)=cast(j,k)
Next
Next

For j=0 To 18
For k=0 To 13
	chipin(i,j,k)=0
Next
Next

Next

HideEntity gunner3D
HideEntity earth3D

;For dc.fortress=Each fortress

;For xex=-4 To 4
;For yey=-4 To 4
;makechip(dc.fortress,xex*3,yey*3)
;Next
;Next

;Next


End Function


Function scoring()


FlushKeys()

If mscore>=bosco(8)
titlerun=2
ename=1
For ik=8 To 1 Step -1
If mscore>=bosco(ik)
If ik<8 Then board$(ik+1)=board$(ik):bosco(ik+1)=bosco(ik):vcode$(ik+1)=vcode$(ik)
If ik>1 And mscore<bosco(ik-1) Then board$(ik)="":bosco(ik)=mscore:ep=ik
If ik=1 Then board$(ik)="":bosco(ik)=mscore:ep=ik
EndIf
Next

;gencode(mscore)
;vcode$(ep)=code$

EndIf

End Function

Function load()
sev=OpenFile("invascores")
If sev<>0

For kg=1 To 8
board$(kg)=ReadString(sev)
bosco(kg)=ReadInt(sev)
vcode$(kg)=ReadString(sev)
Next


CloseFile sev
EndIf

End Function


Function save()
sev=WriteFile("invascores")

For kg=1 To 8
WriteString sev,board$(kg)
WriteInt sev,bosco(kg)
WriteString sev,vcode$(kg)
Next


CloseFile sev

End Function

Function readbuffer(which,xsize,ysize,buffername)

SetBuffer ImageBuffer(buffername)

LockBuffer
For i = 0 To xsize
	For j = 0 To ysize
		If which=1 Then tpix(i,j) = ReadPixelFast(i,j)
		If which=2 Then tspix(i,j) = ReadPixelFast(i,j)
		If which=3 Then ttpix(i,j) = ReadPixelFast(i,j)
		If which=4 Then ali(1,i,j) = ReadPixelFast(i,j)
		If which=5 Then cast(i,j) = ReadPixelFast(i,j)
		If which=6 Then pix(i,j) = ReadPixelFast(i,j)
		If which=7 Then msh(i,j) = ReadPixelFast(i,j)
		If which=8 Then ali(2,i,j) = ReadPixelFast(i,j)
		If which=9 Then ali(3,i,j) = ReadPixelFast(i,j)
		If which=10 Then shi(i,j) = ReadPixelFast(i,j)
		If which=11 Then cra(i,j) = ReadPixelFast(i,j)
	Next
Next
UnlockBuffer

End Function

Function ufoarrives()

waveref=1
While many(waveref)>0
waveref=waveref+1
Wend

many(waveref)=1
orbit(waveref)=1
side(waveref)=0

dd=beatwaves/4
If dd>9 Then dd=9

nfoe.foe = New foe
nfoe\out#=400
nfoe\alien=100
whichpos=Int(Rnd#(2)+0.5)

If whichpos=1 Then nfoe\centro=nplace-180
If whichpos=2 Then nfoe\centro=nplace

whichdir=Int(Rnd#(2)+0.5)

If whichdir=1 Then rotate#(waveref)=0.5:nfoe\fang#=nfoe\centro-30
If whichdir=2 Then rotate#(waveref)=-0.5:nfoe\fang#=nfoe\centro+30

nfoe\inwave=waveref
nfoe\ensort=2
nfoe\direc=1
nfoe\shield#=0 ;dd*0.3
nfoe\smax#=0 ;dd*0.3
nfoe\weapons=1
nfoe\firate=1
nfoe\speed=1
nfoe\foe3D1=CopyEntity(mship3D)
nfoe\current=nfoe\foe3D1
;nfoe\shown=1
;nfoe\foe3D2=CopyEntity(mship3D)
;nfoe\foe3D3=CopyEntity(mship3D)


ufohere=1

End Function




Function foecollides()

;invader collisions

For nfoe.foe = Each foe


xypos(nfoe\out#,nfoe\fang#)


If nfoe\shield#>0 And nfoe\shield#<nfoe\smax#
nfoe\shield#=nfoe\shield#+0.001

If Int(nfoe\shield#*1000) Mod 10=0

shieldcolor(nfoe\shield3D,nfoe\shield#)


EndIf

EndIf


If nfoe\shield#>0 And sshim=0

dd=(nfoe\shield#*10)+1
If dd=16 Then dd=15

;DrawImage ashil(dd),newx#,newy#
;drawthing(newx#,newy#,ryc#,nfoe\shield#,4)
EndIf



If playerdead=0
If ((160+120*Sin(angle#)-ox#-12)^2+(300-120*Cos(angle#)-oy#)^2)^0.5<15

youexplode()
message=3
foedie(nfoe.foe,2)
foegone=1

EndIf

If pulse#>0 And ((160+120*Sin(angle#)-ox#-12)^2+(300-120*Cos(angle#)-oy#)^2)^0.5<30

pulse#=0
foedie(nfoe.foe,2)
foegone=1

EndIf

EndIf

If foegone=0

For fort.fortress = Each fortress

If ((160+150*Sin(fort\ang#)-ox#)^2+(300-150*Cos(fort\ang#)-oy#)^2)^0.5<20

If castcol(ox#,oy#)

newexplo(160+150*Sin(fort\ang#),300-150*Cos(fort\ang#),0)

For ka.fortchip = Each fortchip

If ka\pfort = fort\num

FreeEntity ka\name
Delete ka

EndIf

Next

HideEntity fort\fort3D
Delete fort


foedie(nfoe.foe,2)
foegone=1

comment$="WARNING: SHIELD DESTROYED !"
ncomment=1
comwait=MilliSecs()

newmessage(1,0)

EndIf

EndIf

Next

EndIf


If foegone=0

For bull.bullet = Each bullet

If foegone=0

If bull\ally<>2

bullgone=0

If nfoe\shield#>0

If ImagesCollide(arockt(bull\va),bull\x#,bull\y#,0,shield,ox#,oy#,0)

newexplo(bull\x#,bull\y#,1)

If bull\split>0
newbullets(0,0,bull\x#,bull\y#,0,bull\ang#-45,1,bull\split-1)
newbullets(0,0,bull\x#,bull\y#,0,bull\ang#+45,1,bull\split-1)
EndIf

If powers(7)=0 Or bull\ally=3 
bullgone=1
bhit#=bhit#+0.5
FreeEntity bull\bull3D
Delete bull
EndIf


nfoe\shield#=nfoe\shield#-0.5
score=score+5

shieldcolor(nfoe\shield3D,nfoe\shield#)

If nfoe\shield#<=0
nfoe\shield#=0
FreeEntity nfoe\shield3D
EndIf

EndIf
EndIf


If bullgone=0


If nfoe\ensort=2 Then region=20 Else region=15


If ((bull\x#-ox#)^2+(bull\y#-oy#)^2)^0.5<region And bull\out#>nfoe\out#-15

If bull\ang#<nfoe\fang#-180 Then bull\ang#=bull\ang#+360
If bull\ang#>nfoe\fang#+180 Then bull\ang#=bull\ang#-360

close#=Abs(bull\ang#-nfoe\fang#)

If bull\split>0
newbullets(0,0,bull\x#,bull\y#,0,bull\ang#-45,1,bull\split-1)
newbullets(0,0,bull\x#,bull\y#,0,bull\ang#+45,1,bull\split-1)
EndIf

bsource=bull\ally

If powers(7)=0 Or bull\ally=3
FreeEntity bull\bull3D
Delete bull
EndIf

If powers(7)=1 Then bfired#=bfired#+1


bhit#=bhit#+1

If nfoe\alien<100
scoreup=alvalue(nfoe\alien)
If powers(13)=1 And bsource=1 Then scoreup=scoreup*3
score=score+scoreup
EndIf

If nfoe\alien=100 
If Int(close#-0.5)>=3 Then comment$="OK":bonus=100:which=1
If Int(close#-0.5)=2 Then comment$="GOOD":bonus=200:which=2
If Int(close#-0.5)=1 Then comment$="GREAT":bonus=400:which=3
If Int(close#-0.5)=0 Then comment$="EXCELLENT":bonus=600:which=4
If close#<0.2 Then comment$="PERFECT":bonus=bonus+400:which=5
If powers(13)=1 And bsource=1 Then bonus=bonus*3

ncomment=1
comwait=MilliSecs()
score=score+bonus
what=bonus+which

newmessage(4,what)

EndIf

foedie(nfoe.foe,1)
PlaySound blown

EndIf

EndIf

EndIf

EndIf

Next

EndIf

Next

End Function

Function toggles(source)


If ename=0
;If KeyHit(31) Then savescreenshot()

npress=0

If KeyHit(50) Or JoyHit(4)
mtoggle=1-mtoggle
If mtoggle=0 Then PauseChannel musc
If mtoggle=0 Then help$="MUSIC OFF"
If mtoggle=1 Then ResumeChannel musc
If mtoggle=1 Then help$="MUSIC ON"
menumes=1:menuwait=MilliSecs():npress=1
EndIf
If KeyHit(46) Or JoyHit(3)
ctoggle=1-ctoggle
If ctoggle=0 Then help$="KEYBOARD CONTROL"
If ctoggle=1 Then help$="JOYPAD CONTROL"
menumes=1:menuwait=MilliSecs():npress=1
EndIf
If KeyHit(30) Or JoyHit(6)
atoggle=1-atoggle
If atoggle=0 Then help$="AUTOFIRE OFF"
If atoggle=1 Then help$="AUTOFIRE ON"
menumes=1:menuwait=MilliSecs():npress=1
EndIf

EndIf

If menumes=1

If source=2 And npress=1
DrawImage screenpic,0,0
EndIf

SetFont font2

Color 255,255,255
Text 320-StringWidth(help$)/2,0,help$
If MilliSecs()-menuwait>500
menumes=0
If source=2
DrawImage screenpic,0,0
EndIf

EndIf

If ingame=0 Then SetFont font2
If ingame=1 Then SetFont font

EndIf

End Function


Function newbullets(triple,spread,inx#,iny#,outer#,angat#,which,split)

For mn=1 To 5

genbul=0
If mn=1 Then genbul=1
If mn=2 And triple=1 Then aside=-1:aimat=0:genbul=1
If mn=3 And triple=1 Then aside=1:aimat=0:genbul=1
If mn=4 And spread=1 Then aimat=-1:aside=0:genbul=1
If mn=5 And spread=1 Then aimat=1:aside=0:genbul=1

If genbul=1

bull.bullet=New bullet

bull\x#=inx#+outer#*Sin(angat#)+aside*10*Cos(angat#)
bull\y#=iny#-outer#*Cos(angat#)+aside*10*Sin(angat#)
bull\ang#=angat#+aimat*30
bull\split=split

If bull\ang#<0 Then bull\ang#=bull\ang#+360
If bull\ang#>360 Then bull\ang#=bull\ang#-360

bull\ally=which
If which<>2 Then bfired#=bfired#+1

If bull\ally<>2 Then bull\bull3D=CopyEntity(bullet3D)
If bull\ally=2 Then bull\bull3D=CopyEntity(abullet3D)

RotateEntity bull\bull3D,0,0,-bull\ang#

EndIf

Next

End Function

Function bullcontrol()

;controls bullets

For bull.bullet = Each bullet

bspeed=3
If bull\ally=1 And powers(5)=1 Then bspeed=6

bull\x#=bull\x#+Sin(bull\ang#)*bspeed
bull\y#=bull\y#-Cos(bull\ang#)*bspeed

radial(bull\x#,bull\y#)

sang#=bull\ang#-angle#

While sang#<0
sang#=sang#+360
Wend

While sang#>360
sang#=sang#-360
Wend

bull\va=sang#/5
bull\vx#=newx#
bull\vy#=newy#
bull\out#=dist#

Next

For bull.bullet = Each bullet


radial(bull\x#,bull\y#)

bullgone=0

For xbull.bullet = Each bullet

If bull\ally<>2 And xbull\ally=2

If ImagesCollide(arockt(bull\va),bull\vx#,bull\vy#,0,arockt(xbull\va),xbull\vx#,xbull\vy#,0)

If powers(7)=0 Or bull\ally=3
bullgone=1:bhit#=bhit#+0.5
EndIf

FreeEntity xbull\bull3D
Delete xbull

newexplo(bull\x#,bull\y#,1)

EndIf

EndIf


Next



If bullgone=1
FreeEntity bull\bull3D
Delete bull

EndIf

If bullgone=0


;If bull\ally=1 Then DrawImage rockt(bull\va),newx#,newy#
;If bull\ally=2 Then DrawImage arockt(bull\va),newx#,newy#

PositionEntity bull\bull3D,(bull\x#/100)-1.6,1.2-(bull\y#/100),1.6
bullgone=0

For acrate.crate = Each crate

xypos(acrate\out#,acrate\ang#)

If ((newx#-bull\vx#)^2+(newy#-bull\vy#)^2)^0.5<15
newexplo(160+acrate\out#*Sin(acrate\ang#),300-acrate\out#*Cos(acrate\ang#),0)

FreeEntity acrate\crate3D
Delete acrate
If powers(7)=0 Or bull\ally=3 Then bullgone=1

EndIf

Next

radial(bull\x#,bull\y#)

oreach#=110
If bull\ally=2 And powers(8)=1 Then oreach#=170

If dist#>350 Or dist#<oreach# Then bullgone=1


If dist#<oreach#
If dist#<110 Then score=score-2
If score<0 Then score=0
newexplo(bull\x#,bull\y#,1)
EndIf

If bullgone=1
FreeEntity bull\bull3D
Delete bull

EndIf

If bullgone=0

If bull\ally=2


If playerdead=0

If ImagesCollide(arockt(bull\va),newx#,newy#,0,gunner,160,180,0)
message=1
bullgone=1
youexplode()
FreeEntity bull\bull3D
Delete bull
EndIf
EndIf


If bullgone=0
If ImagesCollide(arockt(bull\va),newx#,newy#,0,shield,160,180,0)

If pulse#>0
newexplo(bull\x#,bull\y#,1)
FreeEntity bull\bull3D
Delete bull
;pulse#=pulse#-0.5
If pulse#<0 Then pulse#=0

EndIf
EndIf
EndIf

EndIf
EndIf
EndIf

Next

;check for bullet collision with forts


For bull.bullet = Each bullet

If powers(5)=0 Or bull\ally=2

radial(bull\x#,bull\y#)

bullgone=0

hitcheck(bull\x#,bull\y#)

If bullgone=0
hitcheck(bull\x#+Sin(bull\ang#)*1.5,bull\y#-Cos(bull\ang#)*1.5)
EndIf

If bullgone=1
FreeEntity bull\bull3D
Delete bull

EndIf

EndIf

Next


End Function


Function drawvaders()

;draw invaders and control their movement

;If debug=0 Then LockBuffer

numaliens=aliencount

aliencount=0

For nfoe.foe = Each foe

xypos(nfoe\out#,nfoe\fang#)
aliencount=aliencount+1

If nfoe\ensort=2 Then wdraw=3 Else wdraw=1


alienx#=Sin(nfoe\fang#-speed#)*nfoe\out#/100
alieny#=Cos(nfoe\fang#-speed#)*nfoe\out#/100-1.8


PositionEntity nfoe\current,alienx#,alieny#,1.6
RotateEntity nfoe\current,0,0,-nfoe\fang#


If nfoe\shield#>0
PositionEntity nfoe\shield3D,alienx#,alieny#,1.6
RotateEntity nfoe\shield3D,0,0,-nfoe\fang#
EndIf

;drawthing(newx#,newy#,ryc#,nfoe\alien,wdraw)

lo#=100/nfoe\out#
aliensp#=0.7*0.95^(many(nfoe\inwave))

If powers(12)=0

If nfoe\fang#<nfoe\centro-120*lo# And rotate#(nfoe\inwave)<0 Then rotate#(nfoe\inwave)=0.5:side(nfoe\inwave)=1
If nfoe\fang#>nfoe\centro+120*lo# And rotate#(nfoe\inwave)>0 Then rotate#(nfoe\inwave)=-0.5:side(nfoe\inwave)=1

angturn#=rotate#(nfoe\inwave)*2*lo#*aliensp#*nfoe\speed

If orbit(nfoe\inwave)=200 Then nfoe\fang#=nfoe\fang#+angturn#

EndIf

If side(nfoe\inwave)>0 And nfoe\ensort=2 And nfoe\direc=1
nfoe\direc=-1
orbit(nfoe\inwave)=1
EndIf


foegone=0

If side(nfoe\inwave)>0 Or orbit(nfoe\inwave)<200

govrate=many(nfoe\inwave)
If orbit(nfoe\inwave)<200 Then govrate=28

If nfoe\ensort=1 Then nfoe\out#=nfoe\out#-1*0.98^(govrate)
If nfoe\ensort=2
nfoe\out#=nfoe\out#-0.6*nfoe\direc

If nfoe\direc=-1 And orbit(nfoe\inwave)>100
many(nfoe\inwave)=0

FreeEntity nfoe\foe3D1
FreeEntity nfoe\foe3D2
FreeEntity nfoe\foe3D3

If nfoe\shield#>0
FreeEntity nfoe\shield3D
EndIf


Delete nfoe
StopChannel ufosound
ufohere=0
foegone=1
EndIf

EndIf
EndIf

If foegone=0
If nfoe\out#<115+powers(8)*60
foedie(nfoe.foe,2)
foegone=1

If powers(8)=0
youexplode()
message=2
EndIf

If powers(8)=1 Then PlaySound blown

EndIf
EndIf

;wave collison checking
If foegone=0

For ofoe.foe = Each foe

If nfoe\inwave<>ofoe\inwave And nfoe\ensort=ofoe\ensort

If Abs(nfoe\out#-ofoe\out#)<=15

apart#=nfoe\fang#-ofoe\fang#
If apart#<-180 Then apart#=apart#+360
If apart#>180 Then apart#=apart#-360 

If Abs(apart#)<=10*lo#

If nfoe\centro<>ofoe\centro
If apart#<0 Then rotate#(nfoe\inwave)=-0.5:rotate#(ofoe\inwave)=0.5
If apart#>0 Then rotate#(nfoe\inwave)=0.5:rotate#(ofoe\inwave)=-0.5
EndIf

If nfoe\centro=ofoe\centro

oldwave=ofoe\inwave

For pfoe.foe = Each foe

If pfoe\inwave=oldwave Then pfoe\inwave=nfoe\inwave

Next

many(nfoe\inwave)=many(nfoe\inwave)+many(oldwave)
many(oldwave)=0
orbit(nfoe\inwave)=200

EndIf

EndIf

EndIf

EndIf

Next

EndIf

Next

;If debug=0 Then UnlockBuffer


For dd=1 To 10
If orbit(dd)>0 And orbit(dd)<200 Then orbit(dd)=orbit(dd)+1
If side(dd)>0 Then side(dd)=side(dd)+1
If side(dd)=10 Then side(dd)=0
Next

End Function


Function playerstuff()


newshot=0

If playerdead<>1

goleft=0:goright=0
firedown=0:firehit=0
pausing=0

If ctoggle=0
If KeyDown(203) Then goleft=1
If KeyDown(205) Then goright=1
If KeyDown(57) Then firedown=1
If KeyHit(57) Or atoggle=1 Then firehit=1
If KeyHit(208) Then pausing=1
EndIf

If ctoggle=1
If JoyHat()=270 Then goleft=1
If JoyHat()=90 Then goright=1
If JoyXDir()=-1 Then goleft=1
If JoyXDir()=1 Then goright=1

If JoyDown(1) Then firedown=1
If JoyHit(1) Or atoggle=1 Then firehit=1
If JoyHit(2) Then pausing=1
EndIf

hspeed#=0.1+powers(5)*0.1

If goleft=1 Then speed#=speed#-hspeed#
If goright=1 Then speed#=speed#+hspeed#

dtarget=300:htarget=300
If powers(3)=1 Then dtarget=100:htarget=100
If powers(5)=1 Then dtarget=dtarget/2:htarget=htarget/2

If firedown=1 And MilliSecs()-butime>dtarget Then newshot=1
If firehit=1 And MilliSecs()-butime>htarget Then newshot=1
If pausing=1 Then mprint=4

EndIf

If newshot=1

PlaySound laser
butime=MilliSecs()

special=0
If powers(6)=1 Then special=3

newbullets(powers(1),powers(2),160,300,130,angle#,1,special)

EndIf

angle#=angle#+speed#

If angle#<0 Then angle#=angle#+360
If angle#>360 Then angle#=angle#-360

speed#=speed#*0.925

End Function


Function newexplo(expx#,expy#,major)

bang.explo = New explo
bang\xp#=expx#
bang\yp#=expy#
bang\etype=major
If major=0 Then PlaySound blown
If major=1 Then PlaySound cancel

bang\explo3D=CopyEntity(exp3D(1))
PositionEntity bang\explo3D,(bang\xp#/100)-1.6,1.2-(bang\yp#/100),1.6

End Function


Function setupentity(ent,alpha#,onpiv)

ScaleSprite ent,swidth#,sheight#
SpriteViewMode ent,2

PositionEntity ent,0,10,1.6
EntityAlpha ent,alpha#
HideEntity ent

If onpiv=1 Then EntityParent(ent,pivot)

End Function



Function savescreenshot()   
iFileNumber% = 0  
Repeat  iFileNumber = iFileNumber + 1  
sFileName$ = "invadershot" + String$("0", 3 - Len(Str$(iFileNumber))) + iFileNumber + ".jpg"  
Until Not(FileType(sFileName))   
SaveBuffer FrontBuffer(), sFileName   
End Function


Function shieldcolor(entity,level#)

green#=level#
If green#>1.5 Then green#=1.5
redblue#=level#
If redblue#>1.5 Then redblue#=3-redblue#
EntityColor entity,170*redblue#,170*green#,170*redblue#

End Function

Function onscreen(entity)

CameraProject camera,EntityX(entity,True),EntityY(entity,True),EntityZ(entity,True)

If ProjectedX()>-40 And ProjectedX()<680 And ProjectedY()>-40 And ProjectedY()<520
Return(True)
EndIf

Return(False)

End Function


Function newsprite(comment$,filename$)

image=CreateImage(StringWidth(comment$),20)

If Not(FileType("invasion/extras/"+filename$+".bmp"))


SetBuffer ImageBuffer(image)

Color 255,255,255

Text 0,0,comment$

ok=SaveImage(image,"invasion/extras/"+filename$+".bmp")

EndIf

nimage=loadmaskedsprite("invasion/extras/"+filename$+".bmp",4)
ScaleSprite nimage,ImageWidth(image)*0.0025,ImageHeight(image)*0.0025

Return(nimage)


End Function



Function newmessage(mtype,varb)

If lives>0

start$=Left$(comment$,4)


this.smessage = New smessage
this\name=CreatePivot()


If mtype=1
dsprite=copysprite(warning,this\name,1)
EndIf

If mtype=2
dsprite=copysprite(incoming,this\name,2)

numsprite(varb,3,0.04,2,this\name)

EndIf

If mtype=3
dsprite=copysprite(accuracy,this\name,3)

numsprite(varb,4,-0.05,3,this\name)

fsprite=copysprite(points,this\name,3)
PositionEntity fsprite,0.1,-0.1,0

EndIf

If mtype=4
hgood=varb Mod 100
tbonus=varb-hgood

dsprite=copysprite(mothmes(hgood),this\name,4)

numsprite(tbonus,4,-0.05,4,this\name)

fsprite=copysprite(points,this\name,4)
PositionEntity fsprite,0.1,-0.1,0

EndIf

If mtype=5
dsprite=copysprite(pupmes(varb),this\name,5)
EndIf


TurnEntity this\name,30,0,0

PositionEntity this\name,0,-0.3,0.3;True
RotateEntity pivot2,0,0,0
EntityParent this\name,pivot2
TurnEntity pivot2,0,0,EntityRoll(pivot)
EntityParent this\name,pivot

EndIf

End Function

Function numsprite(tnum,digi,xright#,rnum,attach)

For dc=1 To digi

If tnum>0 Or rnum=2

number=tnum Mod 10

;num1=((varb-num1)/10) Mod 10

esprite=copysprite(digisp(number),attach,rnum)
PositionEntity esprite,xright#-0.04*(dc-1),-0.1,0

tnum=(tnum-number)/10

EndIf

Next

End Function


Function copysprite(source,parent,colset)

aaa=CopyEntity(source)
EntityParent aaa,parent
EntityOrder aaa,-1
SpriteViewMode aaa,2
If colset=1 Then EntityColor aaa,255,200,100
If colset=2 Then EntityColor aaa,128,128,255
If colset=3 Then EntityColor aaa,255,255,0
If colset=4 Then EntityColor aaa,255,0,255
If colset=5 Then EntityColor aaa,255,128,0

Return(aaa)

End Function


Function loadmaskedsprite(filename$,flags=0,r=0,g=0,b=0)

	curimage=LoadImage(filename$)
	swidth#=ImageWidth(curimage)*0.005
	sheight#=ImageHeight(curimage)*0.005
	FreeImage(curimage)	
	
	;Loads a sprite and masks it with the specified r,g,b values
	
	temp = CreateTexture (1, 1, flags)
	WritePixel 0, 0, ((r Shl 16) + (g Shl 8) + b) And $00FFFFFF, TextureBuffer (temp)
	trgb = ReadPixel (0, 0, TextureBuffer (temp))
	r = trgb Shr 16 And %11111111
	g = trgb Shr 8 And %11111111
	b = trgb And %11111111
	FreeTexture temp
	
	
	texture = LoadTexture (filename$, flags)
	
		;If anyt=cnk
	;texture = bugtexture
	;EndIf
	
	tBuffer = GraphicsBuffer ()
									; Store current buffer	
	SetBuffer TextureBuffer (texture)						; Use texture's buffer
	
	
	LockBuffer GraphicsBuffer ()							; Lock it for 'fast' pixel access
	
	
	; Read each pixel of texture...
	
	For x = 0 To TextureWidth (texture) - 1
		For y = 0 To TextureHeight (texture) - 1
		

			rgb = ReadPixelFast (x, y) And $00FFFFFF		; Read pixel, strip alpha value			
			
			
			If rgb = ((r Shl 16) + (g Shl 8) + b)			; If pixel = rgb mask...	
				WritePixelFast x, y, $00000000				; ... make transparent, else...
			Else
			
			
																		; Not rgb mask pixel, so...
				WritePixelFast x, y, rgb Or $FF000000		; ... make 'solid'
			EndIf

		Next
	Next
		

	UnlockBuffer GraphicsBuffer ()							; Unlock texture buffer

	sprite = CreateSprite ()								; Create blank sprite
	EntityTexture sprite, texture							; Apply masked texture
	
	SetBuffer tBuffer										; Reset graphics buffer as at start
	Return sprite											; Return masked sprite
End Function




.invaderdata
;30 waves of aliens

Data 3,3,3,3,3,3,3
Data 2,2,2,2,2,2,2
Data 1,1,1,1,1,1,1
Data 1,1,1,1,1,1,1

Data 0,0,3,3,3,0,0
Data 0,12,2,25,2,12,0
Data 0,0,1,1,1,0,0
Data 0,0,0,1,0,0,0

Data 0,5,0,5,0,5,0
Data 0,2,2,2,2,2,0
Data 0,0,1,1,1,0,0
Data 0,0,1,1,1,0,0

Data 13,0,13,0,13,0,13
Data 2,0,2,0,2,0,2
Data 1,0,1,0,1,0,1
Data 1,0,1,0,1,0,1

Data 3,0,0,0,0,0,3
Data 0,2,0,0,0,2,0
Data 0,0,1,17,1,0,0
Data 0,0,0,1,0,0,0

Data 3,3,3,14,3,3,3
Data 2,2,2,2,2,2,2
Data 1,1,1,1,1,1,1
Data 0,0,0,19,0,0,0

Data 0,4,0,0,0,4,0
Data 13,0,13,0,13,0,13
Data 12,0,12,0,12,0,12
Data 11,0,11,0,11,0,11

Data 16,3,3,3,3,3,16
Data 16,2,2,2,2,2,16
Data 16,1,1,1,1,1,16
Data 16,1,1,1,1,1,16

Data 3,3,3,3,3,3,3
Data 2,2,2,2,2,2,2
Data 9,9,9,9,9,9,9
Data 9,9,9,9,9,9,9

Data 3,3,3,3,3,3,3
Data 0,2,2,2,2,2,0
Data 0,0,1,1,1,0,0
Data 0,0,0,4,0,0,0

Data 15,15,15,15,15,15,15
Data 2,2,2,2,2,2,2
Data 1,1,1,1,1,1,1
Data 1,1,1,1,1,1,1

Data 0,0,0,53,0,0,0
Data 2,2,53,8,53,2,2
Data 0,0,0,53,0,0,0
Data 1,1,1,1,1,1,1

Data 6,3,3,3,3,3,6
Data 2,2,6,2,6,2,2
Data 1,6,1,1,1,6,1
Data 1,1,1,16,1,1,1

Data 1,1,1,1,1,1,1
Data 1,2,3,94,3,2,1
Data 1,2,3,94,3,2,1
Data 1,1,1,1,1,1,1

Data 0,0,13,13,13,0,0
Data 0,0,12,55,12,0,0
Data 0,0,11,11,11,0,0
Data 0,0,9,9,9,0,0

Data 3,0,3,38,3,0,3
Data 0,2,0,2,0,2,0
Data 1,0,1,0,1,0,1
Data 0,1,0,1,0,1,0

Data 0,0,0,37,0,0,0
Data 0,0,2,2,2,0,0
Data 0,1,1,1,1,1,0
Data 1,0,14,14,14,0,1

Data 16,16,16,16,16,16,16
Data 2,2,2,2,2,2,2
Data 1,1,1,1,1,1,1
Data 1,1,1,1,1,1,1

Data 4,4,4,4,4,4,4
Data 5,5,5,5,5,5,5
Data 6,6,6,6,6,6,6
Data 11,11,11,11,11,11,11

Data 13,23,33,43,33,23,13
Data 2,12,22,32,22,12,2
Data 1,1,11,21,11,1,1
Data 1,1,1,11,1,1,1

Data 0,93,93,93,93,93,0
Data 2,2,2,2,2,2,2
Data 1,1,1,1,1,1,1
Data 1,1,1,1,1,1,1

Data 3,17,3,27,3,17,3
Data 2,2,2,2,2,2,2
Data 1,1,1,1,1,1,1
Data 1,1,1,1,1,1,1

Data 0,3,0,0,0,3,0
Data 0,0,2,24,2,0,0
Data 0,0,1,24,1,0,0
Data 0,1,0,0,0,1,0

Data 1,1,12,53,12,1,1
Data 0,0,0,4,0,0,0
Data 1,1,12,53,12,1,1
Data 0,0,0,0,0,0,0

Data 3,3,3,13,3,3,3
Data 2,2,2,12,2,2,2
Data 1,1,1,11,1,1,1
Data 1,1,1,11,1,1,1

Data 4,5,6,18,6,5,4
Data 2,3,4,5,4,3,2
Data 1,2,3,4,3,2,1
Data 1,1,1,1,1,1,1

Data 14,3,3,37,3,3,14
Data 0,2,2,2,2,2,0
Data 0,0,1,1,1,0,0
Data 0,0,0,37,0,0,0

Data 3,33,63,93,63,33,3
Data 2,22,42,62,42,22,2
Data 1,11,21,31,21,11,1
Data 1,11,21,31,21,11,1

Data 18,18,0,0,0,18,18
Data 18,18,0,14,0,18,18
Data 0,0,11,11,11,0,0
Data 0,0,11,11,11,0,0

Data 0,0,3,3,3,0,0
Data 0,0,2,97,2,0,0
Data 0,0,14,14,14,0,0
Data 0,0,1,1,1,0,0

Data -1